using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Delta
{
    public class Delta
    {
        public static void Main()
        {
        CategoryBuilder.Create("Delta Octon", "Delta Octon...",ModAPI.LoadSprite("Thumbnail.png"));

            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Keroser -D8M",
                    DescriptionOverride = "A silicon based humanoid. Its body seems to have an aura of dark matter.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Keroser_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprite/Skin.png");
                        var flesh = ModAPI.LoadTexture("sprite/Flesh.png");
                        var bone = ModAPI.LoadTexture("sprite/Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

			var person = Instance.GetComponent<PersonBehaviour>();
                        foreach (var body in person.Limbs)
                        {
                	body.BaseStrength = 12f;
                        body.Health = 40f;
                        body.InitialHealth = 40f;
                        body.ShotDamageMultiplier = 0.4f;
                       	body.BreakingThreshold = 9f;
			body.RegenerationSpeed = 0.4f;
			body.CirculationBehaviour.ImmuneToDamage = true;
			body.gameObject.AddComponent<Keroser>();
                        }

			person.SetBodyTextures(skin, null, null, 1);
			person.SetBruiseColor(0, 0, 0); 
			person.SetSecondBruiseColor(0, 0, 0); 
			person.SetThirdBruiseColor(0, 00, 0);
			person.SetRottenColour(0, 0, 0);
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Trooper -D8M",
                    DescriptionOverride = "A Keroser in advanced combat armor.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Trooper_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprite/Trooper.png");
                        var flesh = ModAPI.LoadTexture("sprite/Flesh.png");
                        var bone = ModAPI.LoadTexture("sprite/Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

			var person = Instance.GetComponent<PersonBehaviour>();
                        foreach (var body in person.Limbs)
                        {
                        body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                	body.BaseStrength = 12f;
			body.Numbness *= 0f;
                        body.Health = 40f;
                        body.InitialHealth = 40f;
                        body.ShotDamageMultiplier = 0f;
                       	body.BreakingThreshold = 10f;
			body.RegenerationSpeed = 0.5f;
			body.CirculationBehaviour.ImmuneToDamage = true;
			body.gameObject.AddComponent<Keroser>();
                        }

			person.SetBodyTextures(skin, null, null, 1);
			person.SetBruiseColor(0, 0, 0); 
			person.SetSecondBruiseColor(0, 0, 0); 
			person.SetThirdBruiseColor(0, 00, 0);
			person.SetRottenColour(0, 0, 0);
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Trooper Helmet -D8M",
                    DescriptionOverride = "An advanced helmet worn by D8's troopers.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Helmet_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Helmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 44f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 44;

                        Instance.FixColliders();
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Trooper Backpack -D8M",
                    DescriptionOverride = "A backpack for D8's troopers for all their backpacking needs.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Backpack_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Backpack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 44f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 44;

                        Instance.FixColliders();
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Pilot -D8M",
                    DescriptionOverride = "A Keroser in a modified combat armor that enables them to breathe in space and survive the pressure and radiation present.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Pilot_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprite/Pilot.png");
                        var flesh = ModAPI.LoadTexture("sprite/Flesh.png");
                        var bone = ModAPI.LoadTexture("sprite/Bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

			var person = Instance.GetComponent<PersonBehaviour>();
                        foreach (var body in person.Limbs)
                        {
                        body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                	body.BaseStrength = 12f;
			body.Numbness *= 0f;
                        body.Health = 40f;
                        body.InitialHealth = 40f;
                        body.ShotDamageMultiplier = 0f;
                       	body.BreakingThreshold = 10f;
			body.RegenerationSpeed = 0.5f;
			body.CirculationBehaviour.ImmuneToDamage = true;
			body.gameObject.AddComponent<Keroser>();
                        }

			person.SetBodyTextures(skin, null, null, 1);
			person.SetBruiseColor(0, 0, 0); 
			person.SetSecondBruiseColor(0, 0, 0); 
			person.SetThirdBruiseColor(0, 00, 0);
			person.SetRottenColour(0, 0, 0);
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pilot Helmet -D8M",
                    DescriptionOverride = "A sealed helmet for the pilot.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Pilot_Helmet_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Pilot_Helmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 44f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 44;

                        Instance.FixColliders();
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Combat Knife -D8M",
                    DescriptionOverride = "A combat knife. An impostor's favorite weapon.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Knife_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Knife.png");
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Assault Rifle -D8M",
                    DescriptionOverride = "A rapid firing assault rifle.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Assault_Rifle_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/Assault_Rifle_1.wav"),
			ModAPI.LoadSound("sound/Assault_Rifle_2.wav"),
			ModAPI.LoadSound("sound/Assault_Rifle_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.63f,0.109f);
			firearm.InitialInaccuracy = 0.012f;
                        firearm.Automatic = true;
                        firearm.AutomaticFireInterval = 0.077f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Assault_Rifle.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); 
            		customCartridge.name = "Assault Rifle -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.6f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Assault_Rifle_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Heavy Assault Rifle -D8M",
                    DescriptionOverride = "A heavy assault rifle.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Heavy_Assault_Rifle_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/Heavy_Assault_Rifle_1.wav"),
			ModAPI.LoadSound("sound/Heavy_Assault_Rifle_2.wav"),
			ModAPI.LoadSound("sound/Heavy_Assault_Rifle_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.66f,0.106f);
			firearm.InitialInaccuracy = 0.01f;
                        firearm.Automatic = true;
                        firearm.AutomaticFireInterval = 0.1f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Heavy_Assault_Rifle.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("7.62x39mm"); 
            		customCartridge.name = "Heavy Assault Rifle -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.8f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Heavy_Assault_Rifle_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Combat Shotgun -D8M",
                    DescriptionOverride = "A tactical shotgun.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Shotgun_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/Shotgun_1.wav"),
			ModAPI.LoadSound("sound/Shotgun_2.wav"),
			ModAPI.LoadSound("sound/Shotgun_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.6f,0.088f);
			firearm.InitialInaccuracy = 0.098f;
			firearm.BulletsPerShot = 5;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Shotgun.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm"); 
            		customCartridge.name = "Combat Shotgun -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.6f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Shotgun_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Automatic Shotgun -D8M",
                    DescriptionOverride = "A very violent, fully-automatic tactical shotgun.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Auto_Shotgun_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/Shotgun_1.wav"),
			ModAPI.LoadSound("sound/Shotgun_2.wav"),
			ModAPI.LoadSound("sound/Shotgun_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.6f,0.12f);
			firearm.InitialInaccuracy = 0.098f;
                        firearm.Automatic = true;
                        firearm.AutomaticFireInterval = 0.18f;
			firearm.BulletsPerShot = 5;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Auto_Shotgun.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm"); 
            		customCartridge.name = "Automatic Shotgun -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.6f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Auto_Shotgun_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "General-Purpose Machine Gun -D8M",
                    DescriptionOverride = "A general-purpose machine gun often mounted as defence.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/LMG_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/LMG_1.wav"),
			ModAPI.LoadSound("sound/LMG_2.wav"),
			ModAPI.LoadSound("sound/LMG_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.79f,0.069f);
			firearm.InitialInaccuracy = 0.015f;
                        firearm.Automatic = true;
                        firearm.AutomaticFireInterval = 0.072f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/LMG.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm"); 
            		customCartridge.name = "General-Purpose Machine Gun -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.8f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/LMG_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Designated Marksman Rifle -D8M",
                    DescriptionOverride = "A sniper rifle that fires medium caliber cartridges. Used against basic infantry.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DMR_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/DMR_1.wav"),
			ModAPI.LoadSound("sound/DMR_2.wav"),
			ModAPI.LoadSound("sound/DMR_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.79f,0.06f);
			firearm.InitialInaccuracy = 0.002f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DMR.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("7.62x51mm"); 
            		customCartridge.name = "Designated Marksman Rifle -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.8f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/DMR_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Anti-Materiel Marksman Rifle -D8M",
                    DescriptionOverride = "Fires .50 BMG rounds. Great against lightly armored targets.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/APS_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/APS_1.wav"),
			ModAPI.LoadSound("sound/APS_2.wav"),
			ModAPI.LoadSound("sound/APS_3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.86f,0.06f);
			firearm.InitialInaccuracy = 0f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/APS.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("50 BMG"); 
            		customCartridge.name = "Designated Marksman Rifle -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.8f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/APS_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Grenade Launcher -D8M",
                    DescriptionOverride = "A grenade launcher that fires a grenade at high velocities.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Grenade_Launcher_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                     	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Grenade_Launcher.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("sound/Grenade_Launcher.wav");

                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
                   	Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("40mm Grenade -D8M");
                   	Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 2f;
                   	Instance.GetComponent<ProjectileLauncherBehaviour>().barrelPosition = new Vector3(0.6f,0.1f);

                     	Instance.FixColliders();

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Grenade_Launcher_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stielhandgranate"),
                    NameOverride = "40mm Grenade -D8M",
                    DescriptionOverride = "A small but deadly explosive fired from a grenade launcher.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Launched_Grenade_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                     	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Launched_Grenade.png");

                     	Instance.GetComponent<ExplosiveBehaviour>().Range = 10f;
                     	Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 0f;
                     	Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;

                   	Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                     	Instance.FixColliders();

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Launched_Grenade_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Handgun -D8M",
                    DescriptionOverride = "A conveniant handgun.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Handgun_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/9mm1.wav"),
			ModAPI.LoadSound("sound/9mm2.wav"),
			ModAPI.LoadSound("sound/9mm3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.2f,0.07f);
			firearm.InitialInaccuracy = 0.03f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Handgun.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            		customCartridge.name = "Handgun -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.6f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Handgun_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Submachine Gun -D8M",
                    DescriptionOverride = "An automatic SMG.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Submachine_Gun_View.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("sound/9mm1.wav"),
			ModAPI.LoadSound("sound/9mm2.wav"),
			ModAPI.LoadSound("sound/9mm3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.52f,0.14f);
			firearm.InitialInaccuracy = 0.035f;
                        firearm.Automatic = true;
                        firearm.AutomaticFireInterval = 0.077f;
                        firearm.EjectShells = false;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Submachine_Gun.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
            		customCartridge.name = "Submachine Gun -D8M";
                        customCartridge.Damage *= 3.3f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.ImpactForce = 0.6f;
            		firearm.Cartridge = customCartridge;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Submachine_Gun_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Laser Pointer"),
                    NameOverride = "Underbarrel Laser Pointer -D8M",
                    DescriptionOverride = "A laser pointer that is to be mounted under a firearm's barrel.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Underbarrel_Laser_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                     	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Underbarrel_Laser.png");
                     	Instance.FixColliders();
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stielhandgranate"),
                    NameOverride = "Conventional Grenade -D8M",
                    DescriptionOverride = "A basic grenade.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Grenade_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Grenade.png");
                   	Instance.FixColliders();
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pink Explosive"),
                    NameOverride = "Plasma Grenade -D8M",
                    DescriptionOverride = "An advanced handgrenade useful against armored targets. It has a small range, so it has to be thrown precisely.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Plasma_Grenade_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Plasma_Grenade.png");
                   	Instance.FixColliders();

                     	Instance.GetComponent<ExplosiveBehaviour>().Range = 3f;
                     	Instance.GetComponent<ExplosiveBehaviour>().Delay = 3f;

                     	Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                     	Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                     	Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.1f;

            		var Effect = new GameObject("Glow");
            		Effect.transform.SetParent(Instance.transform);
            		Effect.transform.rotation = Instance.transform.rotation;
            		Effect.transform.localPosition = new Vector3(0f, .0f);
            		Effect.transform.localScale = new Vector3(1f, 1f);
            		var EffectSprite = Effect.AddComponent<SpriteRenderer>();
            		EffectSprite.sprite = ModAPI.LoadSprite("sprite/Plasma_Grenade_Light.png");
            		EffectSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            		EffectSprite.color = new Color32(138, 138, 138, 10);
            		EffectSprite.sortingLayerName = "Object";
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Landmine"),
                    NameOverride = "Landmine -D8M",
                    DescriptionOverride = "A regular landmine.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Landmine_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                     	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Landmine.png");
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Rod -D8M",
                    DescriptionOverride = "A polymer rod.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Rod_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Rod.png");
                    }
                }
            );
            //
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Heavy Rod -D8M",
                    DescriptionOverride = "A heavier, more durable polymer rod.",
                    CategoryOverride = ModAPI.FindCategory("Delta Octon"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Heavy_Rod_View.png"),
                    AfterSpawn = (Instance) =>
                    {
                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Heavy_Rod.png");
                    }
                }
            );
        }
    }
}